import { Plugin } from 'vite';
import { ESLint } from 'eslint';
import { FilterPattern } from '@rollup/pluginutils';

/** ESlint plugin options, extending from ESlint options */
interface Options extends ESLint.Options {
    /** A single file, or array of files, to include when linting */
    include?: FilterPattern;
    /** A single file, or array of files, to exclude when linting */
    exclude?: FilterPattern;
    /** Custom error formatter or the name of a built-in formatter */
    formatter?: string | ESLint.Formatter['format'];
    /** The warings found will be emitted */
    throwOnWarning?: boolean;
    /** The errors found will be emitted */
    throwOnError?: boolean;
}

declare function eslintPlugin(options?: Options): Plugin;

export { Options, eslintPlugin as default };
